--Fractal demonstrator    v1.0 Nicholas Metcalfe 5/98
include graphics.e
include c_math.e

integer xmax, ymax
sequence max
procedure init_screen()
  object vid
  vid = graphics_mode(#13)
  vid = video_config()
  xmax = vid[5]
  ymax = vid[6]
  max = vid[5..6]
  --sequence w
  --w = {}
  --for x = 0 to 255 do
  --  w = w & {{floor(x / 4), floor(x / 4), floor(x / 4)}}
  --end for
  --all_palette(w)
end procedure
init_screen()

atom timer, potential
integer iterations, bailout, key, iter, bail, colour
sequence frac_max, frac_min, frac_param, delta
sequence c, z, z1
object p
-- Initial parameters ------------------------------------------
iterations = 55
bailout = 1000
frac_max = {1.5, 1.5}
frac_min = {-2.5, -1.5}
frac_param = {0.425, 0.315}
p = 3
----------------------------------------------------------------
delta = (frac_max - frac_min) / max
potential = 0
timer = time()
for col = 0 to xmax do
  key = get_key()
  if key = 27 then abort(0) end if
  for row = 0 to ymax do
    iter = 0
    c = frac_min + {col, row} * delta
    z = c 
--(1) -- Mandel / Julia type change (rem'd = mandel) ----    
    --c = frac_param
    -----------------------------------------------------
    z1 = z
    bail = 0
    while iter < iterations and not(bail) do 
--(2) -- Escape-time fractal types ----------------------
      -->> fast Mandel
      --z = c_sqr(z) + c
      ---------------------------------------------------
      -->> generalised Mandel
      --z = c_pwr(z, p) + c     
      ---------------------------------------------------
      -->> Spider
      --z = c_pwr(z, p) + c                  
      --  c = c_div(c, {2, 0}) + z
      ---------------------------------------------------
      -->> Marksmandel
      --z = c_mul(c_pwr(c, p - 1), c_sqr(z)) + c 
      ---------------------------------------------------
      -->> Barnsley I 
      --if z[1] * c[2] + z[2] * c[1] >= 0 then  
      --  z = c_mul(z - {1, 0}, c)
      --else  
      --  z = c_mul(z + {1, 0}, c)
      --end if
      ---------------------------------------------------
      -->> Barnsley II
      --if z[1] > 0 then
      --  z = {(z[1] * z[1]) - (z[2] * z[2]) - 1, 2 * z[1] * z[2]}      
      --else
      --  z = {(z[1] * z[1]) - (z[2] * z[2]) - 1 + (c[1] * z[1]),
      --       (2 * z[1] * z[2]) + c[2] * z[1]}
      --end if
      ---------------------------------------------------
      -->> Sharon 1
      --z = z + c_sqr(z) + c
      ---------------------------------------------------
      -->> Sharon star
      --z = c_pwr(z, 4) + c_div({1, 0}, c)  
      ---------------------------------------------------
      -->> Sharon space probe
      z = c_mul(c_div(c_sqr(z), {2, 0}) + c, c_div(c_sqr(z), {2, 0}) + c)
      ---------------------------------------------------
      
--(3) -- Bailout criteria for escape-time types ---------
      bail = (c_mod(z) >= bailout)
      --bail = (z[1] * z[1] >= bailout) and (z[2] * z[2] >= bailout)
      --bail = power(abs(z[1]) + abs(z[2]), 2) >= bailout
      --bail = (z[1] + z[2]) * (z[1] + z[2]) >= bailout
      ---------------------------------------------------

--(4) -- Polynomial fractals --------------------------------------
      -->> generalised Newton 
      --z = c_div(c_mul({p - 1, 0}, c_pwr(z, p)) + {1, 0}, 
      --    c_mul({p, 0}, c_pwr(z, p - 1)))
      -------------------------------------------------------------

--(5) -- Bailout criteria for Polynomial fractals -----------------      
      --bail = capture(z, z1) z1 = z
      -------------------------------------------------------------
      
      iter=iter + 1
    end while
--(6) -- Colouring methods ---------------------------------------------
    -->> Iterations
    colour = iter
    --------------------------------------------------------------------
    -->> Cellular
    --iter = (z[1] * z[1] < bailout) + (z[2] * z[2] < bailout) * iter
    --------------------------------------------------------------------
    -->> Continuous potential
    --potential = c_mod(z)
    --if  potential <= 0 then potential = 0.1 end if
    --potential = log(potential) + iter * 4
    --colour = abs(floor(((potential / 256) - floor(potential / 256)) * 256))
    --------------------------------------------------------------------
    
    pixel(colour, {col, row})
  end for
end for
position (1, 1)
printf(1, "Timer : %8f", time() - timer)

